diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/eht/emlsr-manager.cc ns-3.42/src/wifi/model/eht/emlsr-manager.cc
--- ns-3.41/src/wifi/model/eht/emlsr-manager.cc	2024-02-09 14:44:08.581795000 -0800
+++ ns-3.42/src/wifi/model/eht/emlsr-manager.cc	2024-05-29 15:29:47.200073700 -0700
@@ -31,6 +31,9 @@
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy-state-helper.h"
 
+#include <iterator>
+#include <sstream>
+
 namespace ns3
 {
 
@@ -228,7 +231,7 @@
 EmlsrManager::GetElapsedMediumSyncDelayTimer(uint8_t linkId) const
 {
     if (const auto statusIt = m_mediumSyncDelayStatus.find(linkId);
-        statusIt != m_mediumSyncDelayStatus.cend() && statusIt->second.timer.IsRunning())
+        statusIt != m_mediumSyncDelayStatus.cend() && statusIt->second.timer.IsPending())
     {
         return m_mediumSyncDuration - Simulator::GetDelayLeft(statusIt->second.timer);
     }
@@ -290,7 +293,12 @@
 void
 EmlsrManager::SetEmlsrLinks(const std::set<uint8_t>& linkIds)
 {
-    NS_LOG_FUNCTION(this);
+    std::stringstream ss;
+    if (g_log.IsEnabled(ns3::LOG_FUNCTION))
+    {
+        std::copy(linkIds.cbegin(), linkIds.cend(), std::ostream_iterator<uint16_t>(ss, " "));
+    }
+    NS_LOG_FUNCTION(this << ss.str());
     NS_ABORT_MSG_IF(linkIds.size() == 1, "Cannot enable EMLSR mode on a single link");
 
     if (linkIds != m_emlsrLinks)
@@ -335,7 +343,7 @@
             action.protectedEhtAction ==
                 WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
         {
-            if (m_transitionTimeoutEvent.IsRunning())
+            if (m_transitionTimeoutEvent.IsPending())
             {
                 // no need to wait until the expiration of the transition timeout
                 m_transitionTimeoutEvent.PeekEventImpl()->Invoke();
@@ -413,7 +421,7 @@
     {
         auto stateHelper = m_staMac->GetWifiPhy(linkId)->GetState();
         NS_ASSERT(stateHelper);
-        NS_ASSERT_MSG(stateHelper->GetState() == TX,
+        NS_ASSERT_MSG(stateHelper->GetState() == WifiPhyState::TX,
                       "Expecting the aux PHY to be transmitting (an RTS frame)");
         NS_ASSERT_MSG(timeToCtsEnd.has_value(),
                       "Aux PHY is sending RTS, expected to get the time to CTS end");
@@ -426,22 +434,22 @@
 
         NS_ASSERT(delay.IsPositive());
         NS_LOG_DEBUG("Schedule main Phy switch in " << delay.As(Time::US));
-        Simulator::Schedule(delay,
-                            &EmlsrManager::SwitchMainPhy,
-                            this,
-                            linkId,
-                            false,
-                            RESET_BACKOFF,
-                            DONT_REQUEST_ACCESS);
+        m_ulMainPhySwitch[linkId] = Simulator::Schedule(delay,
+                                                        &EmlsrManager::SwitchMainPhy,
+                                                        this,
+                                                        linkId,
+                                                        false,
+                                                        RESET_BACKOFF,
+                                                        DONT_REQUEST_ACCESS);
     }
 
     DoNotifyUlTxopStart(linkId);
 }
 
 void
-EmlsrManager::NotifyTxopEnd(uint8_t linkId)
+EmlsrManager::NotifyTxopEnd(uint8_t linkId, bool ulTxopNotStarted, bool ongoingDlTxop)
 {
-    NS_LOG_FUNCTION(this << linkId);
+    NS_LOG_FUNCTION(this << linkId << ulTxopNotStarted << ongoingDlTxop);
 
     if (!m_staMac->IsEmlsrLink(linkId))
     {
@@ -449,18 +457,51 @@
         return;
     }
 
+    // If the main PHY has been scheduled to switch to this link, cancel the channel switch.
+    // This happens, e.g., when an aux PHY sent an RTS to start an UL TXOP but it did not
+    // receive a CTS response.
+    if (auto it = m_ulMainPhySwitch.find(linkId); it != m_ulMainPhySwitch.end())
+    {
+        if (it->second.IsPending())
+        {
+            NS_LOG_DEBUG("Cancelling main PHY channel switch event on link " << +linkId);
+            it->second.Cancel();
+        }
+        m_ulMainPhySwitch.erase(it);
+    }
+
+    // Unblock the other EMLSR links and start the MediumSyncDelay timer, provided that the TXOP
+    // included the transmission of at least a frame and there is no ongoing DL TXOP on this link.
+    // Indeed, the UL TXOP may have ended because the transmission of a frame failed and the
+    // corresponding TX timeout (leading to this call) may have occurred after the reception on
+    // this link of an ICF starting a DL TXOP. If the EMLSR Manager unblocked the other EMLSR
+    // links, another TXOP could be started on another EMLSR link (possibly leading to a crash)
+    // while the DL TXOP on this link is ongoing.
+    if (ongoingDlTxop)
+    {
+        NS_LOG_DEBUG("DL TXOP ongoing");
+        return;
+    }
+    if (ulTxopNotStarted)
+    {
+        NS_LOG_DEBUG("TXOP did not even start");
+        return;
+    }
+
     DoNotifyTxopEnd(linkId);
 
     Simulator::ScheduleNow([=, this]() {
         // unblock transmissions and resume medium access on other EMLSR links
+        std::set<uint8_t> linkIds;
         for (auto id : m_staMac->GetLinkIds())
         {
-            if (m_staMac->IsEmlsrLink(id))
+            if ((id != linkId) && m_staMac->IsEmlsrLink(id))
             {
-                m_staMac->UnblockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
                 m_staMac->GetChannelAccessManager(id)->NotifyStopUsingOtherEmlsrLink();
+                linkIds.insert(id);
             }
         }
+        m_staMac->UnblockTxOnLink(linkIds, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
 
         StartMediumSyncDelayTimer(linkId);
     });
@@ -474,7 +515,7 @@
     // if a MediumSyncDelay timer is running for the link on which the main PHY is going to
     // operate, set the CCA ED threshold to the MediumSyncDelay OFDM ED threshold
     if (auto statusIt = m_mediumSyncDelayStatus.find(linkId);
-        statusIt != m_mediumSyncDelayStatus.cend() && statusIt->second.timer.IsRunning())
+        statusIt != m_mediumSyncDelayStatus.cend() && statusIt->second.timer.IsPending())
     {
         NS_LOG_DEBUG("Setting CCA ED threshold of PHY " << phy << " to " << +m_msdOfdmEdThreshold
                                                         << " on link " << +linkId);
@@ -508,6 +549,12 @@
     NS_ASSERT_MSG(mainPhy != m_staMac->GetWifiPhy(linkId),
                   "Main PHY is already operating on link " << +linkId);
 
+    if (mainPhy->IsStateSwitching())
+    {
+        NS_LOG_DEBUG("Main PHY is already switching, ignore new switching request");
+        return;
+    }
+
     // find the link on which the main PHY is operating
     auto currMainPhyLinkId = m_staMac->GetLinkForPhy(mainPhy);
     NS_ASSERT_MSG(currMainPhyLinkId, "Current link ID for main PHY not found");
@@ -526,11 +573,14 @@
                   "We should not ask the main PHY to switch channel while transmitting");
 
     // request the main PHY to switch channel
-    auto delay = mainPhy->GetChannelSwitchDelay();
-    NS_ASSERT_MSG(noSwitchDelay || delay <= m_lastAdvTransitionDelay,
-                  "Transition delay (" << m_lastAdvTransitionDelay.As(Time::US)
-                                       << ") should exceed the channel switch delay ("
-                                       << delay.As(Time::US) << ")");
+    const auto delay = mainPhy->GetChannelSwitchDelay();
+    const auto pifs = mainPhy->GetSifs() + mainPhy->GetSlot();
+    NS_ASSERT_MSG(noSwitchDelay || delay <= std::max(m_lastAdvTransitionDelay, pifs),
+                  "Channel switch delay ("
+                      << delay.As(Time::US)
+                      << ") should be shorter than the maximum between the Transition delay ("
+                      << m_lastAdvTransitionDelay.As(Time::US) << ") and a PIFS ("
+                      << pifs.As(Time::US) << ")");
     if (noSwitchDelay)
     {
         mainPhy->SetAttribute("ChannelSwitchDelay", TimeValue(Seconds(0)));
@@ -629,7 +679,7 @@
             // switching to a link on which an aux PHY gained a TXOP and sent an RTS, but the CTS
             // is not received and the UL TXOP ends before the main PHY channel switch is
             // completed. The MSD timer is started on the link left "uncovered" by the main PHY
-            if (auto phy = m_staMac->GetWifiPhy(id); phy && !it->second.timer.IsRunning())
+            if (auto phy = m_staMac->GetWifiPhy(id); phy && !it->second.timer.IsPending())
             {
                 NS_LOG_DEBUG("Setting CCA ED threshold on link "
                              << +id << " to " << +m_msdOfdmEdThreshold << " PHY " << phy);
@@ -654,7 +704,7 @@
 
     auto timerIt = m_mediumSyncDelayStatus.find(linkId);
 
-    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsRunning());
+    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsPending());
 
     timerIt->second.timer.Cancel();
     MediumSyncDelayTimerExpired(linkId);
@@ -667,7 +717,7 @@
 
     auto timerIt = m_mediumSyncDelayStatus.find(linkId);
 
-    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && !timerIt->second.timer.IsRunning());
+    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && !timerIt->second.timer.IsPending());
 
     // reset the MSD OFDM ED threshold
     auto phy = m_staMac->GetWifiPhy(linkId);
@@ -697,7 +747,7 @@
 
     const auto timerIt = m_mediumSyncDelayStatus.find(linkId);
 
-    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsRunning());
+    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsPending());
     NS_ASSERT(timerIt->second.msdNTxopsLeft != 0);
 
     if (timerIt->second.msdNTxopsLeft)
@@ -713,7 +763,7 @@
 
     auto timerIt = m_mediumSyncDelayStatus.find(linkId);
 
-    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsRunning());
+    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsPending());
     timerIt->second.msdNTxopsLeft.reset();
 }
 
@@ -724,7 +774,7 @@
 
     auto timerIt = m_mediumSyncDelayStatus.find(linkId);
 
-    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsRunning());
+    NS_ASSERT(timerIt != m_mediumSyncDelayStatus.cend() && timerIt->second.timer.IsPending());
     return timerIt->second.msdNTxopsLeft == 0;
 }
 
@@ -916,19 +966,23 @@
         auto cam = m_staMac->GetChannelAccessManager(linkId);
         cam->NotifySwitchingEmlsrLink(auxPhy, channel, linkId);
 
-        void (WifiPhy::*fp)(const WifiPhyOperatingChannel&) = &WifiPhy::SetOperatingChannel;
-        Simulator::ScheduleNow(fp, auxPhy, channel);
+        auxPhy->SetOperatingChannel(channel);
 
         // the way the ChannelAccessManager handles EMLSR link switch implies that a PHY listener
         // is removed when the channel switch starts and another one is attached when the channel
-        // switch ends. In the meantime, no PHY is connected to the ChannelAccessManager. Inform
-        // the ChannelAccessManager that this channel switch is related to EMLSR operations, so
-        // that the ChannelAccessManager does not complain if events requiring access to the PHY
-        // occur during the channel switch.
-        cam->NotifyStartUsingOtherEmlsrLink();
-        Simulator::Schedule(auxPhy->GetChannelSwitchDelay(),
-                            &ChannelAccessManager::NotifyStopUsingOtherEmlsrLink,
-                            cam);
+        // switch ends. In the meantime, no PHY is connected to the ChannelAccessManager. Thus,
+        // reset all backoffs (so that access timeout is also cancelled) when the channel switch
+        // starts and request channel access (if needed) when the channel switch ends.
+        cam->ResetAllBackoffs();
+        Simulator::Schedule(auxPhy->GetChannelSwitchDelay(), [=, this]() {
+            for (const auto& [acIndex, ac] : wifiAcList)
+            {
+                m_staMac->GetQosTxop(acIndex)->StartAccessAfterEvent(
+                    linkId,
+                    Txop::DIDNT_HAVE_FRAMES_TO_TRANSMIT,
+                    Txop::CHECK_MEDIUM_BUSY);
+            }
+        });
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/eht/emlsr-manager.h ns-3.42/src/wifi/model/eht/emlsr-manager.h
--- ns-3.41/src/wifi/model/eht/emlsr-manager.h	2024-02-09 14:44:08.581795000 -0800
+++ ns-3.42/src/wifi/model/eht/emlsr-manager.h	2024-05-29 15:29:47.200073700 -0700
@@ -187,8 +187,12 @@
      * Notify the end of a TXOP on the given link.
      *
      * \param linkId the ID of the given link
+     * \param ulTxopNotStarted whether this is a notification of the end of an UL TXOP that did
+     *                      not even start (no frame transmitted)
+     * \param ongoingDlTxop whether a DL TXOP is ongoing on the given link (if true, this is
+     *                      a notification of the end of an UL TXOP)
      */
-    void NotifyTxopEnd(uint8_t linkId);
+    void NotifyTxopEnd(uint8_t linkId, bool ulTxopNotStarted = false, bool ongoingDlTxop = false);
 
     /**
      * Check whether the MediumSyncDelay timer is running for the STA operating on the given link.
@@ -472,6 +476,9 @@
         m_mainPhyChannels; //!< link ID-indexed map of operating channels for the main PHY
     std::map<uint8_t, WifiPhyOperatingChannel>
         m_auxPhyChannels; //!< link ID-indexed map of operating channels for the aux PHYs
+    std::map<uint8_t, EventId> m_ulMainPhySwitch; //!< link ID-indexed map of timers started when
+                                                  //!< an aux PHY gains an UL TXOP and schedules
+                                                  //!< a channel switch for the main PHY
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/frame-exchange-manager.cc ns-3.42/src/wifi/model/frame-exchange-manager.cc
--- ns-3.41/src/wifi/model/frame-exchange-manager.cc	2024-02-09 14:44:08.581795000 -0800
+++ ns-3.42/src/wifi/model/frame-exchange-manager.cc	2024-05-29 15:29:47.200073700 -0700
@@ -29,7 +29,7 @@
 #include "ns3/log.h"
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
+#define NS_LOG_APPEND_CONTEXT WIFI_FEM_NS_LOG_APPEND_CONTEXT
 
 // Time (in nanoseconds) to be added to the PSDU duration to yield the duration
 // of the timer that is started when the PHY indicates the start of the reception
@@ -73,7 +73,7 @@
 {
     NS_LOG_FUNCTION(this);
     m_txTimer.Cancel();
-    if (m_navResetEvent.IsRunning())
+    if (m_navResetEvent.IsPending())
     {
         m_navResetEvent.Cancel();
     }
@@ -273,7 +273,7 @@
     NS_LOG_FUNCTION(this << "PSDU reception started for " << psduDuration.As(Time::US)
                          << " (txVector: " << txVector << ")");
 
-    NS_ASSERT_MSG(!m_txTimer.IsRunning() || !m_navResetEvent.IsRunning(),
+    NS_ASSERT_MSG(!m_txTimer.IsRunning() || !m_navResetEvent.IsPending(),
                   "The TX timer and the NAV reset event cannot be both running");
 
     // No need to reschedule timeouts if PSDU duration is null. In this case,
@@ -288,7 +288,7 @@
         m_channelAccessManager->NotifyAckTimeoutResetNow();
     }
 
-    if (m_navResetEvent.IsRunning())
+    if (m_navResetEvent.IsPending())
     {
         m_navResetEvent.Cancel();
     }
@@ -347,10 +347,10 @@
     WifiTxParameters txParams;
     txParams.m_txVector =
         GetWifiRemoteStationManager()->GetDataTxVector(mpdu->GetHeader(), m_allowedWidth);
-    txParams.m_protection = m_protectionManager->TryAddMpdu(mpdu, txParams);
-    txParams.m_acknowledgment = m_ackManager->TryAddMpdu(mpdu, txParams);
     txParams.AddMpdu(mpdu);
     UpdateTxDuration(mpdu->GetHeader().GetAddr1(), txParams);
+    txParams.m_protection = m_protectionManager->TryAddMpdu(mpdu, txParams);
+    txParams.m_acknowledgment = m_ackManager->TryAddMpdu(mpdu, txParams);
 
     SendMpduWithProtection(mpdu, txParams);
 
@@ -401,7 +401,7 @@
     // and SendCtsToSelf() can reuse this value.
     NS_ASSERT(m_txParams.m_acknowledgment);
 
-    if (m_txParams.m_acknowledgment->acknowledgmentTime == Time::Min())
+    if (!m_txParams.m_acknowledgment->acknowledgmentTime.has_value())
     {
         CalculateAcknowledgmentTime(m_txParams.m_acknowledgment.get());
     }
@@ -648,8 +648,8 @@
     NS_LOG_FUNCTION(this << header << size << &txParams << fragmentedPacket);
 
     NS_ASSERT(txParams.m_acknowledgment &&
-              txParams.m_acknowledgment->acknowledgmentTime != Time::Min());
-    Time durationId = txParams.m_acknowledgment->acknowledgmentTime;
+              txParams.m_acknowledgment->acknowledgmentTime.has_value());
+    auto durationId = *txParams.m_acknowledgment->acknowledgmentTime;
 
     // if the current frame is a fragment followed by another fragment, we have to
     // update the Duration/ID to cover the next fragment and the corresponding Ack
@@ -705,10 +705,11 @@
     NS_ASSERT(txParams.m_protection && txParams.m_protection->method == WifiProtection::RTS_CTS);
     auto rtsCtsProtection = static_cast<WifiRtsCtsProtection*>(txParams.m_protection.get());
 
-    NS_ASSERT(txParams.m_txDuration != Time::Min());
+    NS_ASSERT(txParams.m_txDuration.has_value());
+    NS_ASSERT(txParams.m_acknowledgment->acknowledgmentTime.has_value());
     rts.SetDuration(GetRtsDurationId(rtsCtsProtection->rtsTxVector,
-                                     txParams.m_txDuration,
-                                     txParams.m_acknowledgment->acknowledgmentTime));
+                                     *txParams.m_txDuration,
+                                     *txParams.m_acknowledgment->acknowledgmentTime));
     Ptr<WifiMpdu> mpdu = Create<WifiMpdu>(Create<Packet>(), rts);
 
     // After transmitting an RTS frame, the STA shall wait for a CTSTimeout interval with
@@ -806,10 +807,11 @@
               txParams.m_protection->method == WifiProtection::CTS_TO_SELF);
     auto ctsToSelfProtection = static_cast<WifiCtsToSelfProtection*>(txParams.m_protection.get());
 
-    NS_ASSERT(txParams.m_txDuration != Time::Min());
+    NS_ASSERT(txParams.m_txDuration.has_value());
+    NS_ASSERT(txParams.m_acknowledgment->acknowledgmentTime.has_value());
     cts.SetDuration(GetCtsToSelfDurationId(ctsToSelfProtection->ctsTxVector,
-                                           txParams.m_txDuration,
-                                           txParams.m_acknowledgment->acknowledgmentTime));
+                                           *txParams.m_txDuration,
+                                           *txParams.m_acknowledgment->acknowledgmentTime));
 
     ForwardMpduDown(Create<WifiMpdu>(Create<Packet>(), cts), ctsToSelfProtection->ctsTxVector);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/frame-exchange-manager.h ns-3.42/src/wifi/model/frame-exchange-manager.h
--- ns-3.41/src/wifi/model/frame-exchange-manager.h	2024-02-09 14:44:08.581795000 -0800
+++ ns-3.42/src/wifi/model/frame-exchange-manager.h	2024-05-29 15:29:47.200073700 -0700
@@ -37,6 +37,9 @@
 
 #include "ns3/object.h"
 
+#define WIFI_FEM_NS_LOG_APPEND_CONTEXT                                                             \
+    std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
+
 namespace ns3
 {
 
@@ -547,7 +550,7 @@
      * \param rtsTxMode the TX mode used to transmit the RTS
      * \param rtsSnr the SNR of the RTS in linear scale
      */
-    void SendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiMode rtsTxMode, double rtsSnr);
+    virtual void SendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiMode rtsTxMode, double rtsSnr);
 
     /**
      * Send CTS after receiving RTS.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-6ghz-band-capabilities.cc ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.cc
--- ns-3.41/src/wifi/model/he/he-6ghz-band-capabilities.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.cc	2024-05-29 15:29:47.200073700 -0700
@@ -0,0 +1,148 @@
+/*
+ * Copyright (c) 2024
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rami Abdallah <abdallah.rami@gmail.com>
+ */
+
+#include "he-6ghz-band-capabilities.h"
+
+namespace ns3
+{
+
+He6GhzBandCapabilities::He6GhzBandCapabilities()
+    : m_capabilitiesInfo{}
+{
+}
+
+WifiInformationElementId
+He6GhzBandCapabilities::ElementId() const
+{
+    return IE_EXTENSION;
+}
+
+WifiInformationElementId
+He6GhzBandCapabilities::ElementIdExt() const
+{
+    return IE_EXT_HE_6GHZ_CAPABILITIES;
+}
+
+uint16_t
+He6GhzBandCapabilities::GetInformationFieldSize() const
+{
+    // Return size of Element ID Extension and
+    // Capabilities Information field in octets
+    return 1 + /* Element ID Ext */ +2 /* Capabilities Information */;
+}
+
+void
+He6GhzBandCapabilities::SetMaxAmpduLength(uint32_t maxAmpduLength)
+{
+    for (uint8_t i = 0; i <= 7; i++)
+    {
+        if ((1UL << (13 + i)) - 1 == maxAmpduLength)
+        {
+            m_capabilitiesInfo.m_maxAmpduLengthExponent = i;
+            return;
+        }
+    }
+    NS_ABORT_MSG("Invalid A-MPDU Max Length value");
+}
+
+uint32_t
+He6GhzBandCapabilities::GetMaxAmpduLength() const
+{
+    return (1UL << (13 + m_capabilitiesInfo.m_maxAmpduLengthExponent)) - 1;
+}
+
+void
+He6GhzBandCapabilities::SetMaxMpduLength(uint16_t length)
+{
+    NS_ABORT_MSG_IF(length != 3895 && length != 7991 && length != 11454,
+                    "Invalid MPDU Max Length value");
+    if (length == 11454)
+    {
+        m_capabilitiesInfo.m_maxMpduLength = 2;
+    }
+    else if (length == 7991)
+    {
+        m_capabilitiesInfo.m_maxMpduLength = 1;
+    }
+    else
+    {
+        m_capabilitiesInfo.m_maxMpduLength = 0;
+    }
+}
+
+uint16_t
+He6GhzBandCapabilities::GetMaxMpduLength() const
+{
+    if (m_capabilitiesInfo.m_maxMpduLength == 0)
+    {
+        return 3895;
+    }
+    if (m_capabilitiesInfo.m_maxMpduLength == 1)
+    {
+        return 7991;
+    }
+    if (m_capabilitiesInfo.m_maxMpduLength == 2)
+    {
+        return 11454;
+    }
+    NS_ABORT_MSG("The value 3 is reserved");
+}
+
+void
+He6GhzBandCapabilities::SerializeInformationField(Buffer::Iterator start) const
+{
+    uint16_t twoBytes = m_capabilitiesInfo.m_minMpduStartSpacing |
+                        (m_capabilitiesInfo.m_maxAmpduLengthExponent << 3) |
+                        (m_capabilitiesInfo.m_maxMpduLength << 6) |
+                        (m_capabilitiesInfo.m_smPowerSave << 9) |
+                        (m_capabilitiesInfo.m_rdResponder << 11) |
+                        (m_capabilitiesInfo.m_rxAntennaPatternConsistency << 12) |
+                        (m_capabilitiesInfo.m_txAntennaPatternConsistency << 13);
+    start.WriteHtolsbU16(twoBytes);
+}
+
+uint16_t
+He6GhzBandCapabilities::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
+{
+    Buffer::Iterator tmp = start;
+    uint16_t twoBytes = start.ReadLsbtohU16();
+    m_capabilitiesInfo.m_minMpduStartSpacing = twoBytes & 0x07;
+    m_capabilitiesInfo.m_maxAmpduLengthExponent = (twoBytes >> 3) & 0x07;
+    m_capabilitiesInfo.m_maxMpduLength = (twoBytes >> 6) & 0x03;
+    m_capabilitiesInfo.m_smPowerSave = (twoBytes >> 9) & 0x03;
+    m_capabilitiesInfo.m_rdResponder = (twoBytes >> 11) & 0x01;
+    m_capabilitiesInfo.m_rxAntennaPatternConsistency = (twoBytes >> 12) & 0x01;
+    m_capabilitiesInfo.m_txAntennaPatternConsistency = (twoBytes >> 13) & 0x01;
+    return start.GetDistanceFrom(tmp);
+}
+
+void
+He6GhzBandCapabilities::Print(std::ostream& os) const
+{
+    os << "HE 6GHz Band Capabilities=[Capabilities Information|"
+       << " Min MPDU start spacing: " << +m_capabilitiesInfo.m_minMpduStartSpacing
+       << " Max A-MPDU Length Exp: " << +m_capabilitiesInfo.m_maxAmpduLengthExponent
+       << " Max MPDU Length: " << +m_capabilitiesInfo.m_maxMpduLength
+       << " SM Power Save: " << +m_capabilitiesInfo.m_smPowerSave
+       << " RD Responder: " << +m_capabilitiesInfo.m_rdResponder
+       << " RX Antenna Pattern: " << +m_capabilitiesInfo.m_rxAntennaPatternConsistency
+       << " TX Antenna Pattern: " << +m_capabilitiesInfo.m_txAntennaPatternConsistency << "]";
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-6ghz-band-capabilities.h ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.h
--- ns-3.41/src/wifi/model/he/he-6ghz-band-capabilities.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.h	2024-05-29 15:29:47.200073700 -0700
@@ -0,0 +1,94 @@
+/*
+ * Copyright (c) 2024
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rami Abdallah <abdallah.rami@gmail.com>
+ */
+
+#ifndef HE_6GHZ_BAND_CAPABILITIES_H
+#define HE_6GHZ_BAND_CAPABILITIES_H
+
+#include "ns3/wifi-information-element.h"
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ *
+ * The HE 6 GHz Band Capabilities (IEEE 802.11ax-2021 9.4.2.263)
+ */
+class He6GhzBandCapabilities : public WifiInformationElement
+{
+  public:
+    He6GhzBandCapabilities();
+
+    WifiInformationElementId ElementId() const override;
+    WifiInformationElementId ElementIdExt() const override;
+    void Print(std::ostream& os) const override;
+
+    /// Capabilities Information field
+    struct CapabilitiesInfo
+    {
+        uint8_t m_minMpduStartSpacing : 3;         ///< Minimum MPDU Start Spacing
+        uint8_t m_maxAmpduLengthExponent : 3;      ///< Maximum A-MPDU Length Exponent (can
+                                                   ///< also be set via convenient methods)
+        uint8_t m_maxMpduLength : 2;               ///< Maximum MPDU Length (can also
+                                                   ///< be set via convenient methods)
+        uint8_t : 1;                               ///< Reserved Bits
+        uint8_t m_smPowerSave : 2;                 ///< SM Power Save
+        uint8_t m_rdResponder : 1;                 ///< RD Responder
+        uint8_t m_rxAntennaPatternConsistency : 1; ///< Receive Antenna Pattern Consistency
+        uint8_t m_txAntennaPatternConsistency : 1; ///< Transmit Antenna Pattern Consistency
+        uint8_t : 2;                               ///< Reserved Bits
+    };
+
+    CapabilitiesInfo m_capabilitiesInfo; ///< capabilities field
+
+    /**
+     * Set the maximum AMPDU length.
+     *
+     * \param maxAmpduLength 2^(13 + x) - 1, x in the range 0 to 7
+     */
+    void SetMaxAmpduLength(uint32_t maxAmpduLength);
+    /**
+     * Return the maximum A-MPDU length.
+     *
+     * \return the maximum A-MPDU length in bytes
+     */
+    uint32_t GetMaxAmpduLength() const;
+
+    /**
+     * Set the maximum MPDU length.
+     *
+     * \param length the maximum MPDU length (3895, 7991 or 11454)
+     */
+    void SetMaxMpduLength(uint16_t length);
+    /**
+     * Get the maximum MPDU length.
+     *
+     * \return the maximum MPDU length in bytes
+     */
+    uint16_t GetMaxMpduLength() const;
+
+  private:
+    uint16_t GetInformationFieldSize() const override;
+    void SerializeInformationField(Buffer::Iterator start) const override;
+    uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+};
+
+} // namespace ns3
+
+#endif /* HE_6GHZ_BAND_CAPABILITY_H */
